#ifndef RESOURCEPOLICY_H_INCLUDED
#define RESOURCEPOLICY_H_INCLUDED

namespace fus {

/*
Les fonctions de nos polices peuvent tre statiques ou non, cela ne change en rien leur utilisation.
Pour les polices ne comportant aucune donne membre, il vaudra mieux tout mettre en static, ainsi on conomisera un
 choua en performances (dans les fonctions statiques, l'objet implicite this n'est pas trimball en interne).
*/
// Objets COM et ressources du moteur - comptage de rfrence intrusif
template <class T>
class CCOMPolicy {
public :

    // Clone la ressource
    static T* Clone(T* Ptr) {

        if (Ptr)
            Ptr->AddRef();
        return Ptr;
    }

    // Gre la libration de la ressource
    static void Release(T* Ptr) {

        if (Ptr)
            Ptr->Release();
    }

    // Echange deux instances - aucune donne membre : ne fait rien
    static void Swap(CCOMPolicy&) {}
};

}

#endif // RESOURCEPOLICY_H_INCLUDED
