#include "CScreenQuad.hpp"

using namespace irr;
using namespace core;
using namespace video;



CScreenQuadPerso::CScreenQuadPerso()
{
	Material.Wireframe = false;
    Material.Lighting = false;
    Material.ZWriteEnable = false;
    Material.BackfaceCulling = false;
//    Material.ZBuffer = video::ECFN_ALWAYS;  //! depth test alway succeds


	/* Vertices are:
	0--1
	| /|
	|/ |
	3--2
	*/
    Vertices[0] = S3DVertex(vector3df(-0.7, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 1));
    Vertices[1] = S3DVertex(vector3df(1.f, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 1));
    Vertices[2] = S3DVertex(vector3df(1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 0));
    Vertices[3] = S3DVertex(vector3df(-1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 0));

    //! backup vertices
//    Vertices[0] = S3DVertex(vector3df(-0.7, 1, 0), vector3df(0, 0, 1), SColor(255,255,255,255), vector2df(0, 0));
//    Vertices[1] = S3DVertex(vector3df(1, 1, 0), vector3df(0, 0, 1), SColor(255,255,255,255), vector2df(1, 0));
//    Vertices[2] = S3DVertex(vector3df(1, -1, 0), vector3df(0, 0, 1), SColor(255,255,255,255), vector2df(1, 1));
//    Vertices[3] = S3DVertex(vector3df(-1, -1, 0), vector3df(0, 0, 1), SColor(255,255,255,255), vector2df(0, 1));

    Indices[0] = 0;
    Indices[1] = 1;
    Indices[2] = 3;
    Indices[3] = 1;
    Indices[4] = 2;
    Indices[5] = 3;


    // S3DVertex(f32 x, f32 y, f32 z, f32 nx, f32 ny, f32 nz, SColor c, f32 tu, f32 tv)


}

#if 0

/// tells position
//core::vector2di => abs
void CScreenQuadPerso::render(irr::video::IVideoDriver* driver, core::vector2df)


void CScreenQuadPerso::render(irr::video::IVideoDriver* driver, core::vector2di& position)

// core::rect srcRect  will play on UV
// core::rect dest


/**
**/


//! draws a 2d image, using a color and the alpha channel of the texture if
//! desired. The image is drawn at pos, clipped against clipRect (if != 0).
//! Only the subtexture defined by sourceRect is used.
void COpenGLDriver::draw2DImage(const video::ITexture* texture,
				const core::position2d<s32>& pos,
				const core::rect<s32>& sourceRect,
				const core::rect<s32>* clipRect, SColor color,
				bool useAlphaChannelOfTexture)
{
	if (!texture)
		return;

	if (!sourceRect.isValid())
		return;

	core::position2d<s32> targetPos(pos);
	core::position2d<s32> sourcePos(sourceRect.UpperLeftCorner);
	// This needs to be signed as it may go negative.
	core::dimension2d<s32> sourceSize(sourceRect.getSize());

	// If clipping
//	if (clipRect)
//	{
//		if (targetPos.X < clipRect->UpperLeftCorner.X)
//		{
//			sourceSize.Width += targetPos.X - clipRect->UpperLeftCorner.X;
//			if (sourceSize.Width <= 0)
//				return;
//
//			sourcePos.X -= targetPos.X - clipRect->UpperLeftCorner.X;
//			targetPos.X = clipRect->UpperLeftCorner.X;
//		}
//
//		if (targetPos.X + sourceSize.Width > clipRect->LowerRightCorner.X)
//		{
//			sourceSize.Width -= (targetPos.X + sourceSize.Width) - clipRect->LowerRightCorner.X;
//			if (sourceSize.Width <= 0)
//				return;
//		}
//
//		if (targetPos.Y < clipRect->UpperLeftCorner.Y)
//		{
//			sourceSize.Height += targetPos.Y - clipRect->UpperLeftCorner.Y;
//			if (sourceSize.Height <= 0)
//				return;
//
//			sourcePos.Y -= targetPos.Y - clipRect->UpperLeftCorner.Y;
//			targetPos.Y = clipRect->UpperLeftCorner.Y;
//		}
//
//		if (targetPos.Y + sourceSize.Height > clipRect->LowerRightCorner.Y)
//		{
//			sourceSize.Height -= (targetPos.Y + sourceSize.Height) - clipRect->LowerRightCorner.Y;
//			if (sourceSize.Height <= 0)
//				return;
//		}
//	}

	// clip these coordinates

	if (targetPos.X<0)
	{
		sourceSize.Width += targetPos.X;
		if (sourceSize.Width <= 0)
			return;

		sourcePos.X -= targetPos.X;
		targetPos.X = 0;
	}

	const core::dimension2d<u32>& renderTargetSize = getCurrentRenderTargetSize();

	if (targetPos.X + sourceSize.Width > (s32)renderTargetSize.Width)
	{
		sourceSize.Width -= (targetPos.X + sourceSize.Width) - renderTargetSize.Width;
		if (sourceSize.Width <= 0)
			return;
	}

	if (targetPos.Y<0)
	{
		sourceSize.Height += targetPos.Y;
		if (sourceSize.Height <= 0)
			return;

		sourcePos.Y -= targetPos.Y;
		targetPos.Y = 0;
	}

	if (targetPos.Y + sourceSize.Height > (s32)renderTargetSize.Height)
	{
		sourceSize.Height -= (targetPos.Y + sourceSize.Height) - renderTargetSize.Height;
		if (sourceSize.Height <= 0)
			return;
	}

	// ok, we've clipped everything.
	// now draw it.
//
//	const core::dimension2d<u32>& ss = texture->getOriginalSize();
//	const f32 invW = 1.f / static_cast<f32>(ss.Width);
//	const f32 invH = 1.f / static_cast<f32>(ss.Height);
//	const core::rect<f32> tcoords(
//			sourcePos.X * invW,
//			sourcePos.Y * invH,
//			(sourcePos.X + sourceSize.Width) * invW,
//			(sourcePos.Y + sourceSize.Height) * invH);
//
//	const core::rect<s32> poss(targetPos, sourceSize);

// destRect
#endif

void CScreenQuadPerso::render(irr::video::IVideoDriver* driver, const core::rectf& destRect)
{

    core::dimension2d<u32> screenSize = driver->getScreenSize();



//    Vertices[0].Pos.set( destRect.UpperLeftCorner.X, destRect.UpperLeftCorner.Y , 0);
//    Vertices[1].Pos.set( destRect.UpperLeftCorner.X, destRect.LowerRightCorner.Y , 0 );
//    Vertices[2].Pos.set( destRect.LowerRightCorner.X, destRect.LowerRightCorner.Y , 0);
//    Vertices[3].Pos.set( destRect.LowerRightCorner.X, destRect.UpperLeftCorner.Y , 0 );

    //Vertices[1].Pos = destRect.LowerRightCorner.X


//    driver->setTransform(video::ETS_PROJECTION, core::IdentityMatrix);
//    driver->setTransform(video::ETS_VIEW, core::IdentityMatrix);
//    driver->setTransform(video::ETS_WORLD, core::IdentityMatrix);

//        drv->drawIndexedTriangleList(&Vertices[0],6,&Indices[0],2);

    //driver->drawIndexedTriangleList(&Vertices[0], 4, &Indices[0], 2);

    driver->setMaterial(Material);

    driver->drawIndexedTriangleList( Vertices, 4, Indices, 2);
}
