#include "binds.hpp"
// definit ici et binde les fct lua necessaires
#include <luabind/luabind.hpp>




//#include "../CSinglePlayerState.hpp"
#include "../entities/player.hpp"
#include "../entities/CBullet.hpp"
#include "../entities/IMultiModeTransformer.hpp"
#include "../entities/IWalkyrie.hpp"
#include <luabind/operator.hpp>
// Include needed policy
#include <luabind/copy_policy.hpp>
//#include <luabind/dependency_policy.hpp>
#include <luabind/out_value_policy.hpp>
#include <luabind/raw_policy.hpp>
#include <luabind/return_reference_to_policy.hpp>
#include <luabind/error.hpp>
#include <boost/any.hpp>

#include "concat.hpp"

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;
using namespace luabind;


//luabind::maketable
//CSinglePlayerState
//CGraphicalLevel* levelMgr
luabind::scope
bindPlayerToLua()
{

    return luabind::class_<IStaticBattery>("IStaticBattery")

        .def("pos",(void (IStaticBattery::*)(const float&,const float& ,const float&))&IStaticBattery::setPosition)
        // raw(_2) because first parameter is this
        .def("getPos",&IStaticBattery::exportPositionToLua, luabind::raw(_2) )
        .def("getDamage",&IStaticBattery::getInflictingDamage )
        .def("getRange",&IStaticBattery::getRange)
        .def("getRotation",&IStaticBattery::getRotation)
        .def("setup",&IStaticBattery::setup)
//        .def("setRange",&IStaticBattery::setRange)
//        .def("setBonus",&IStaticBattery::setBonus)
//        .def("setLife",&IStaticBattery::setLife)
        .def("setTarget",&IStaticBattery::setTarget)
        // setup(life/bonus/range etc...)
//        .def("setMesh",&IStaticBattery::setMesh)
        .def("update",&IStaticBattery::update)
        // TO remove
        .def("getRemainingLife",&IStaticBattery::getRemainingLife)
        .def("updateRotation",&IStaticBattery::updateRotation)
        .def("translate",&IStaticBattery::translate)
        .def("setPosition",(void (IStaticBattery::*)(const float&,const float&,const float&))&IStaticBattery::setPosition)
        .def("setRotationSpeed",&IStaticBattery::setRotationSpeed)
        // defined in "luabind/operator.hpp" ?!
        //.def( luabind::tostring(luabind::self) )const_self
//        .def( luabind::tostring(luabind::const_self ) )
        //.def( luabind::const_self == luabind::other<IStaticBattery>() )
//
//        .def( luabind::concat_operator(luabind::const_self,luabind::other<std::string>() ) )
//        .def( luabind::concat_operator(luabind::const_self,int() ) )
//        .def( luabind::concat_operator(luabind::other<std::string>(),luabind::const_self ) )
        , luabind::class_<CStaticBattery,IStaticBattery>("CStaticBattery")


    , luabind::class_<SModeDescription>("SModeDescription")
        //.def("defineAnimation",&SModeDescription::defineAnimation, luabind::return_reference_to(_1) )
        .def("setAngleBounds",&SModeDescription::setAngleBounds, luabind::return_reference_to(_1) )
        .def("setRange",&SModeDescription::setRange, luabind::return_reference_to(_1) )
        .def("setupSpeeds",&SModeDescription::setupSpeeds, luabind::return_reference_to(_1) )
        .def("setCameraRecul",&SModeDescription::setCameraRecul, luabind::return_reference_to(_1) )


    //, SModeDescription
//    , luabind::class_< IMultiModeTransformer<EWalkyrieMode> >("Transformer")


//    , luabind::class_<IWalkyrie, bases<IMultiModeTransformer<EWalkyrieMode> , SModeDescription> >("IWalkyrie")
//
//            .enum_("Mode")
//            [
//    //            value("Fighter",NWalkyrieModes::Fighter),
//    //            value("Gerwalk",NWalkyrieModes::Gerwalk),
//    //            value("Battloid",NWalkyrieModes::Battloid),
//
//                value("yf19_Fighter",   NWalkyrieModes::yf19_Fighter),
//                value("yf19_Gerwalk",   NWalkyrieModes::yf19_Gerwalk),
//                value("yf19_Battloid",  NWalkyrieModes::yf19_Battloid),
//                value("yf21_Fighter",   NWalkyrieModes::yf21_Fighter),
//                value("yf21_Gerwalk",   NWalkyrieModes::yf21_Gerwalk),
//                value("yf21_Battloid",  NWalkyrieModes::yf21_Battloid)
//
//            ]
//
//        .scope [
//
//            def("getMode",&IWalkyrie::getMode)
//        ]
//

    , luabind::class_<CBullet, luabind::bases<IStaticBattery> >("CBullet")

    // Bases => multiple inheritance
    , luabind::class_<CPlayer, bases<IStaticBattery> >("CPlayer")
//        .enum_("Mode")
//        [
//            value("Fighter",NWalkyrieModes::Fighter),
//            value("Gerwalk",NWalkyrieModes::Gerwalk),
//            value("Battloid",NWalkyrieModes::Battloid)
//        ]
//        .def("processMoves",&CPlayer::processMoves)
        .def("processTransformations",&CPlayer::processTransformations)
//        .def("processShootings",&CPlayer::processShootings)
        // en gros si on decommente les 2 prochaines lignes ca compile pas
//        .def("clearAllowedModes",&CPlayer::clearModes)
        // return_reference_to policy tells luabind that return value is already on the heap
//        .def("allowMode",&CPlayer::allowMode )
        //.def("forceMode",&CPlayer::forceMode )
        // doesn't work
        // TODO should use copy ?
        //.def("getMappingDescription",&CPlayer::getMappingDescription, luabind::copy(luabind::result))
        //.def("getMappingDescription",&CPlayer::getMappingDescription, luabind::raw(_2))


        .enum_("Input")
        [
            value("Forward",        static_cast<int>(NPlayerInput::MoveForward) ),
            value("Backward",       static_cast<int>(NPlayerInput::MoveBackward) ),
            value("Left",           static_cast<int>(NPlayerInput::MoveLeft) ),
            value("Right",          static_cast<int>(NPlayerInput::MoveRight) ),
            value("ModeUp",         static_cast<int>(NPlayerInput::ModeUp) ),
            value("ModeDown",       static_cast<int>(NPlayerInput::ModeDown) ),
            value("MainShoot",      static_cast<int>(NPlayerInput::MainShoot) ),
            value("SecondShoot",    static_cast<int>(NPlayerInput::SecondShoot) )
        ];

    //];

}


