/*
*
* \file entity_player.cpp
*/
#include "player.hpp"
#include "IPlayerAnimator.hpp"
//#include "../CGraphicalLevel.hpp"
#include "../config.hpp"
#include "../fleets/IFleet.hpp"
#include "../fleets/CAlliedFleet.hpp"
#include "CMissile.hpp"
#include "CBullet.hpp"
#include <fusion/logging/CConsoleLogger.hpp>
#include <fusion/maths/macros.hpp>
#include <fusion/macros.hpp>
#include <algorithm> // for min/max
#include "../game_engine.hpp"
#include "../events/CBindCollectionPlayer.hpp"
#include "../fx/CParticleManager.hpp"
#include <utf8.h>
#include <boost/circular_buffer.hpp>
//#include "IMultiModeTransformer.hpp"
#include "IWalkyrie.hpp"
//#include "../events/CPlayerInputCache.hpp"

//#define _PLAYER_DEFAULT_MODE Fighter

using namespace irr;
using namespace core;
using namespace scene;
//using namespace NPlayerInput;


//#define IS_ACTIVE(x) _cachedInput->isActive(x)
#define IS_ACTIVE(x) CachedInput[ static_cast<int>( NPlayerInput::x ) ]
#define FULL_ID(id,no) (id)
#define CACHE_ID(id,no) std::make_pair(id,no)


// TODO remove
//const NWalkyrieModes::ERealMode CPlayer::_virtualModes[2][3] =
//{
//    {
//        NWalkyrieModes::yf19_Fighter,
//        NWalkyrieModes::yf19_Gerwalk,
//        NWalkyrieModes::yf19_Battloid
//    }
//    ,
//    {
//        NWalkyrieModes::yf21_Fighter,
//        NWalkyrieModes::yf21_Gerwalk,
//        NWalkyrieModes::yf21_Battloid
//    }
//};




/// Constructor
CPlayer::CPlayer( ) :
LivesLeft( conf::_DEFAULT_LIVES )
, _elapsedTimeSinceLastOverheat(0)
//_blinksCounter(0),
, _coolingDown(false)
, _missilesLeft( conf::_DEFAULT_STOCK_OF_MISSILES)
, _trackedMissile(nullptr)
, IStaticBattery()
, _targeting(0)
//, _mappingSet(mapping)
, UpdatePositionFunction(nullptr)
//, _engine( CGameEngine::instance() )
, _walkyrie(nullptr)
//IMultiModeTransformer::IMultiModeTransformer(node )

{
    _LOG_DEBUG << "construction du joueur";
    //BOOST_ASSERT(_engine);

    // -- set mapping
    //setMapping(mapping);

    //! TODO
//    _mappingSet = new TMappingSet();

    //!
//    UpdatePositionFunction = &CPlayer::BasicUpdatePositionFunction;

    // assign elapsed times
    _elapsedTimes.fill(0);
}



/// Destructor
CPlayer::~CPlayer()
{

    /// Delete space allocated to each particle system associated with a booster
    /*for(std::vector<SBooster>::iterator i = mShip->mBoosters.begin();i != mShip->mBoosters.end();i++){
        delete i->system;
    }*/
}


void
CPlayer::setAnimator(IPlayerAnimator* animator)
{
    //!
    if(animator != nullptr)
    {
        animator->reset();

        UpdatePositionFunction = animator;
    }
}


void
CPlayer::startCoolingDown()
{
    _coolingDown = true;
    _elapsedTimeSinceLastOverheat = 0;
}

void
CPlayer::stopCoolingDown()
{
    _coolingDown = false;
    _elapsedTimeSinceLastOverheat = 0;
}






//CFleet* enemyFleet
bool
CPlayer::trackNewBattery()
{

    //CStaticBattery* battery = ->getNearestEnemy( this->getPosition() );
// TODO
/*
    //
    CStaticBattery* battery = _level->_enemyFleet->getNextTarget( _trackedBatteries );

    if(battery == 0){
        _LOG_WARNING << "could not find a battery to shoot missile to";

        return false;
    }
    else {

//            // TODO fonction, get Upward direction Forward vector
            TVector3df forward = CGraphicalLevel::getPlayerForwardVector();
            //forward.X = 0.2;
            const TVector3df position = this->getPosition();

            CMissile* missile = _fleet->createAndSetupMissile("models/missile.obj", forward, position);

            missile->setTarget( battery );
//            _INFO << "Missile created";

        // Launch missile !
        _trackedBatteries.push_back(battery);
        return true;
    }
    */

}


bool
CPlayer::startTrackingEnemies()
{

    _INFO << "starts tracking enemies";

    // sort batteries by their
    _targeting = true;
    _trackedBatteries.clear();

    return trackNewBattery();
}


bool
CPlayer::stopTrackingEnemies()
{


    _INFO << "stop tracking enemies";
    _targeting = false;
    //_trackedBatteries.clear();
    return false;
}




////////////////////////////////////////////////////////////////////////////
/// IF button is pressed
////////////////////////////////////////////////////////////////////////////
//        _INFO << "ends targeting enemy, prepare to fire";
//
//        // HAck
//        CStaticBattery* battery = _level->_enemyFleet->getNearestEnemy( this->getPosition() );
//
//        if(battery){
//
//            // TODO fonction, get Upward direction Forward vector
//            TVector3df forward = CGraphicalLevel::getPlayerForwardVector();
//            //forward.X = 0.2;
//            const TVector3df position = this->getPosition();
//
//            CMissile* missile = _fleet->createAndSetupMissile("models/missile.obj", forward, position);
//
//            missile->setTarget( battery );
//            _INFO << "Missile created";
//        }
//        else {
//
//            _INFO << "No battery to fire missiles at !";
//        }
//    }
    //
// CEventManager::_timer->getTime()
// _cachedInput.getMapping( SecondShoot ).checkState()
//


/*
TODO should go into gameEngine
bool
CPlayer::setTransformerModel(const char* meshFilename, const char* leftBoosterName,const char* rightBoosterName)
{


    scene::IAnimatedMesh* mesh = 0;

    mesh = engine().scene()->getMesh( meshFilename );

    if(!mesh)
    {
        _LOG_ERROR << "could not load mesh [" << meshFilename << "]" ;
        return false;
    }

    _node->setMesh( mesh );
    _node->getMaterial(0).Lighting = false;

    irr::scene::IBoneSceneNode* leftBoosterBone = 0;
    irr::scene::IBoneSceneNode* rightBoosterBone = 0;

    // Ca bug ici
    //leftBoosterBone = _node->getJointNode( leftBoosterName );
    //rightBoosterBone = _node->getJointNode( rightBoosterName );


    if(leftBoosterBone)
    {
        _leftBooster->setParent( leftBoosterBone );
    }
    else {
        _LOG_WARNING << "Bone [" << leftBoosterName << "] not found ";
    }


    if(rightBoosterBone)
    {
        _rightBooster->setParent( rightBoosterBone );
    }
    else {
        _LOG_WARNING << "Bone [" << rightBoosterName << "] not found ";
    }


    return true;
}
*/



irr::scene::ISceneNode* CPlayer::getNode()
{
    FUS_ASSERT( _walkyrie );
    return _walkyrie->getNode();
};


bool
CPlayer::setWalkyrie(IWalkyrie* walkyrie)
{
    FUS_ASSERT( _walkyrie == 0);

    _walkyrie = walkyrie;
    _node = _walkyrie->getNode();

    //! Set available modes
    //_walkyrie->clearModes();


    return true;
}



void
CPlayer::onTimeoutDisparition()
{

    // todo ne rien faire ?
}



void
CPlayer::onDeath()
{

    _INFO << "Player died from collision";

}



// TODO revoir cette fonction qui devrait normalement marcher out of the box
// l'adpater existe deja pour std::string
/*
void
CPlayer::getMappingDescription(lua_State* L,const int& id)
{
    int correctedId = id;//std::min(10, std::max(0,id));
//
//    LIMIT_RANGE(correctedId,NPlayerInput::MoveLeft,NPlayerInput::Count);
//    std::string temp;
//    std::wstring wtemp( _cachedInput.getMapping(correctedId).generateDescription().c_str() );
//    utf8::utf16to8(wtemp.begin(),wtemp.end(), std::back_inserter(temp) );

    //lua_pushstring(L,temp.c_str());
}
*/


SStats::SStats() :
//LivesLeft( conf::_DEFAULT_LIVES )
Destroyed(0),
Score(0),
Deaths(0),
NbOfTransformations(0)
{
    //PlayedTimes.assign(0);
}




void
SStats::addKill(CStaticBattery* battery)
{
    //
    Score += battery->getBonus();
    ++Destroyed;
}



//SStats::update
//bool
//CPlayer::addDamage(const int&)
//{
////    // can harm player only if alive
////    if(_state == NState::Alive){
////        //add damages
////    }
//
//    kill();
//    return false;
//}



// TODO a renommer en kill
void
CPlayer::kill()
{
//    --_livesLeft;
    //++_stats.Deaths;
    _damageInflictedOnCollision = 0;

    //return _livesLeft;
}







// TODO getCruiseSpeed
float
CPlayer::getCruiseSpeed()
{

//    float speed = _walkyrie->getSpeed(SModeDescription::DefaultForward);
    // Ne tient pas compte du modifier
//    speed -= IS_ACTIVE(MoveBackward) * _walkyrie->getSpeed(SModeDescription::Backward);
//    speed += IS_ACTIVE(MoveForward) * _walkyrie->getSpeed(SModeDescription::Forward);
    return ( 2 );
}





// TODO
float
CPlayer::getRange() const
{
//    return _walkyrie->getRange();
    return 3;
};





float
CPlayer::getCannonHeatRatio() const {
    return ( (float)_cannonHeat/(float)conf::PLAYER_CANNON_MAX_HEAT );

}


//Player
bool
CPlayer::update(const TTimer::TimeType& elapsedTime, CBindCollectionPlayer::TCache& cache)
{


//    processTransformations(
//                        cache[ NPlayerInput::ModeUp ] ,
//                        cache[ NPlayerInput::ModeDown ]
//                        );


    if( getWalkyrie()->getCurrentMode() == IWalkyrie::TransformingMode)
    {
        _INFO  << "Interpolating model with progress = " << getWalkyrie()->getTransformationAdvancement();
        IWalkyrie::TransformingMode->interpolate( IWalkyrie::TransformingMode->getPreviousMode(),IWalkyrie::TransformingMode->getNextMode(), getWalkyrie()->getTransformationAdvancement() );
    }
    //! to interpolate
//    _walkyrie->update();

    //!
//    if(  (* (this->UpdatePositionFunction))(elapsedTime) )
//    {
//        UpdatePositionFunction = &CPlayer::BasicUpdatePositionFunction;
//    }

/*
    _elapsedTimes[SinceLastShot]           += elapsedTime;
    _elapsedTimes[SinceLastTransformation] += elapsedTime;
    _elapsedTimes[SinceLastMissile]        += elapsedTime;
*/
    // _parameters[o3::NParameters::Range] = _walkyrie->getRange();


    // cools primary weapon if overheated
    // TODO that should start cooling before
//    if(_cannonHeat > 0)
//    {
//
//    }
    _cannonHeat -= conf::PLAYER_CANNON_COOLING_VALUE;

    if( _cannonHeat <= 0)
    {
        _cannonHeat = 0;
        if( coolingDown() )     stopCoolingDown();
    }

//    if( coolingDown() ) {
//        if(_elapsedTimeSinceLastOverheat += elapsedTime) > conf::COOLING_TIME)
//        {
//            stopCoolingDown();
//            _INFO << "Stop cooling down";
//        }
//    }
//    else {
//
//    }


    return true;
}










//void
//CPlayer::FirePrimaryShot()
//{
//
//    // Can't shoot while transforming
//    if(_walkyrie->isTransforming())
//    {
//        _LOG_WARNING << "Cannot shoot because model transforming";
//        return;
//    }
//    else if( coolingDown() )
//    {
//        _LOG_WARNING << "Cannot shoot because cooling down";
//        return;
//    }
//
//
//    _elapsedTimes[SinceLastShot] = 0;
//
//
//    // TODO prendre heat comme timer
//    _cannonHeat += conf::PLAYER_CANNON_SHOT_HEAT_VALUE;
//
//    //_INFO << "heat" << _cannonHeat;
//    if(_cannonHeat >= conf::PLAYER_CANNON_MAX_HEAT)
//    {
////        _cannonHeat = conf::PLAYER_CANNON_MAX_HEAT;
//        startCoolingDown();
//        _INFO << "Start cooling down";
//    }
//
//
//    const TVector3df forwardVec = getPlayerForwardVector();
//
//// TODO remplacer par _fleet
//// This shoot->bullet
//// POSSIBLE BUG ICI
//    //CBullet* bullet = _level->_alliedFleet->createAndSetupBullet("models/missile.obj",
//    CBullet* bullet = getFleet()->createAndSetupBullet("models/missile.obj",
//                                                      forwardVec
//                                                      );
//
//    // Then configure bullet
//    bullet->setPosition( this->getPosition() );
//
//
//
//
//    bullet->setup(
//                  getFleet()->getMesh("models/missile.obj"),
//                  conf::_PLAYER_BULLET_RANGE,
//                  0,        //!< life
//                  5,        //!< damage
//                  0         //!< Bonus
//                  );
//
//
//    _INFO << "bullet shot at position [" << bullet->getPosition() <<  "] isVisible " << bullet->_node->isVisible();
//}


//void
//CPlayer::FireMissiles()
//{
//
//    _INFO << "Firing Missile";
////    _elapsedTimes[SinceLastMissile] = 0;
////
////// TODO verifier qu'il reste des missiles
////    --_missilesLeft;
////
////    if(_level){
////        CStaticBattery* target = 0;
////        target = _level->getNextTarget();
////        if(target){
////            _level->_alliedFleet.addMissile(
////                        "player_bullet",
////                        getPosition(),
////                        target,
////                        core::vector3df(0.1,0,-0.03)
////                    );
//////            _INFO << "player Missile created";
////            //,180,getPosition());
////        }
////    }
//
//}


//Ici on pourrait enlever de l'energie etc.. a chaque transformation

bool
CPlayer::processTransformations(const SBindCache& modeUp, const SBindCache& modeDown)
{

//    auto currentMode = _walkyrie->getCurrentMode();
//    auto targetedMode = currentMode;

    IWalkyrieMode *nextMode = nullptr;
    if( modeUp.justPressed() )
    {

        _INFO << "Mode up pressed";
//        targetedMode =
//        nextMode = _walkyrie->getNextMode();
        if(!_walkyrie->transformIntoNextMode()){
            _LOG_WARNING << "Couldn't target next mode";
        }
        //return true;

    }
    else if( modeDown.justPressed() )
    {

        _INFO << "Mode down pressed";
//        targetedMode  =
        if( !_walkyrie->transformIntoPreviousMode() ) {
            _LOG_WARNING << "Couldn't target previous mode";
        }
    }


//    if(targetedMode != currentMode)
//    {
//        return _walkyrie->transformInto (targetedMode);
//    }
    return true;
}





const bool&
CPlayer::coolingDown() const
{

    //return (_elapsedTimes[Cooldown] == 0);
    return _coolingDown;
}




void
CPlayer::setupNewLife()
{
    // Refill missile stock
    _missilesLeft = conf::_DEFAULT_STOCK_OF_MISSILES;
//    _blinksCounter = 0;
    _node->setVisible(true);
}





#undef IS_ACTIVE
