/**
\file config_manager.h

Refaire pour l'adapter avec le systeme de boost::program_options
*/
#ifndef _BC_IBindCollection_HPP_INCLUDED
#define _BC_IBindCollection_HPP_INCLUDED


#include <irrlicht.h>  // header only
#include <array>
#include <fusion/logging/ILogger.hpp>
#include <boost/bimap.hpp>
#include <boost/optional.hpp>
#include <boost/noncopyable.hpp>
#include <map>
#include <fusion/utilities/SBimap.hpp>
#include "CBindDescriptor.hpp"
//#include "CInputManager.hpp"

#include "../def.hpp"
#include <boost/bimap/bimap.hpp>
#include <boost/bimap/list_of.hpp>
#include <boost/bimap/unordered_set_of.hpp>
#include <boost/bimap/vector_of.hpp>
#include <vector>
#include "CBindDescriptor.hpp"
#include "SCachedState.hpp"
#include <irrlicht.h>
#include <IInputManager.h>

namespace bbi = boost::bimaps;




// fwd declaration
//template<class ID_TYPE>
//class IInputCache;


//struct SAssociatedStruct
//{
//    SAssociatedStruct() {};
//    CBindDescriptor Descriptor;
//    SBindCache State;
//};



/**
BIND_ID
CACHE_ID
or maybe have several collections for one player
**/
template<
        typename BIND_ID,
        typename CACHE_ID
        >
class IBindCollection
//<BIND_ID>
{
public:
    typedef BIND_ID TFullId;  //!< This way we can have several shortcuts associated with a unique action !

    //typedef IInputCache<TBindId> TCache;
    typedef std::map< CACHE_ID, SBindCache> TCache;

protected:
public:

//    IBindCollection( irr::IInputManager* inputMgr ) :
//        _inputMgr(inputMgr)
//    {
//        FUS_ASSERT(_inputMgr != nullptr);
//    };

    IBindCollection( )
    {

    };

    virtual const CBindDescriptor& getBind(TFullId const& id) = 0;
//    virtual const CBindDescriptor& getBind(TFullId const& id) const = 0;


    /**
    Return vector of ids and of size < limit matching the descriptor. Useful to check if a descriptor was already registered
    **/
    std::vector<TFullId>
    getAssociatedIds( CBindDescriptor const& descriptor, std::size_t const& limit) const;



    /**
    No addBind since collection might prevent from adding new binds. Set bind may create binds when inexistant.
    Returns identifier matching current "id" mode with descriptor
    **/
    virtual CBindDescriptor& setBind(TFullId const& id,CBindDescriptor const& descriptor) = 0;

//    virtual bool addBind(TFullId const& id,CBindDescriptor& ) = 0;
    virtual void removeBind(TFullId const& id) = 0;



    /**
    \returns Id of matching descriptor/mode if exists, otherwise returns unitialiazed
    \param[out] id
    \return true if ok
    **/
    virtual bool containBind(CBindDescriptor const& descriptor, TFullId& id) = 0;


    // Essayer de remettre un const devant inputMgr
    /** \brief
     *
     * \param
     * \param
     * \return
     *
    */
//    template<typename T>
//    void updateCache( , T& globalCache) const
//    {
//        TTimeUnit const& currentTime
//        for( SBindCache& cache : globalCache){
//
//        }
//    }


//    template<typename T>
    virtual void updateCache( irr::IInputManager* inputMgr, TCache& cache) const = 0;

};





// mutlimap version
//std::pair<typename TDescriptorList::iterator,typename TDescriptorList::iterator> result = _descriptors.equal_range( descriptor );
//if(result == _descriptors.end())
//for(auto it(result.first) ; it != result.second; ++it){


#endif
