/**
* \file menu.h
* Utiliser std::tr1
**/
#ifndef _BC_CMENUSTATE_HPP_INCLUDED
#define _BC_CMENUSTATE_HPP_INCLUDED


#include "IGameState.hpp"
#include <irrlicht.h>
#include <boost/scoped_ptr.hpp>
#include <array>
#include <boost/ptr_container/ptr_list.hpp>
#include "../IdList.hpp"
//#include "../audio/ISound.hpp"
#include "../utils/C2DSprite.hpp"

// pr faire mvt de camera autour du vaisseau ?
//createFlyCircleAnimator


namespace audio {
class ISound;
}


//class CMenuState : public IGameState<NStateId::MainMenu,false>

DECLARE_GAME_STATE(CMenuState )
{
    INNER_STATE_DECLARATION( CMenuState );

public:

    ~CMenuState();

	bool load(CGameEngine*,irr::scene::ISceneManager*,irr::video::ITexture* );
	void unload();

//	bool isLoaded() const;


    void onResume();
    void onHold();

	void onUpdate(const TTimeUnit& elapsedTime);
	void Draw();

    bool OnEvent(const irr::SEvent& event);

    std::wstring generateDebugData(  ) const;

protected:

    void GUI_CreateMainMenu();              //!< Create main (home) menu

    irr::gui::IGUITab* _menu;

    irr::scene::ISceneNode* _skybox;
    irr::gui::IGUIStaticText* _buildInfoText;


    // TODO should disappear thx to different managers
    typedef boost::ptr_list<C2DSprite> TSpritesMap;
    TSpritesMap _sprites;

    boost::scoped_ptr<audio::ISound> _hoverSound;

//    irr::s32 _materialIds[2];
};


#endif
