/**
* \file single.h
**/
#ifndef IDialogState_HPP
#define IDialogState_HPP

#include "../states/IGameState.hpp"
#include "../events/SCachedState.hpp"
#include <map>
#include <boost/weak_ptr.hpp>
#include <list>
#include <irrlicht.h>
#include <memory>
//#include "../utils/IClock.hpp"



class CSpeech;
class CSpeaker;
//class CFadingImage;



//template<class >
DECLARE_GAME_STATE(IDialogState)
//class IDialogState : public IBasicGameState
{
private:
    bool WaitingForUserInput;
    //typedef std::pair<CSpeaker*,CSpeech*> TDialog;

    irr::gui::IGUITab* _dialogTab;
    irr::gui::IGUIStaticText* _text;
    irr::gui::IGUIStaticText* SpeakerName;
    irr::gui::IGUIListBox* _answers;
    irr::gui::IGUIImage* SpeakerImg;


protected:
    void GUI_CreateDialogTab();

    const bool& waitingForUserInput() const { return WaitingForUserInput;};

public:
//    void updateDialog(speakerName,speakerImgPath,Text)

    void setMessage(const std::string& msg);

    // TODO la je passe forcement le nom du niveau a charger
    IDialogState( const std::string& );
    virtual ~IDialogState();

    void waitForUserInput();

    //
    irr::s32 addAnswer(const std::string& label, const irr::s32& id = -1);
    void clearAnswers();

    //! about speaker
    void setSpeakerName(const std::string& name);
    void setSpeakerTexture( const char* texturePath);


    bool load( CGameEngine*,irr::scene::ISceneManager*,irr::video::ITexture* );
    void unload();



    virtual void onUpdate(const TTimeUnit& elapsedTime) ;


    /////////////////////////////////////////////////////
    ////    important !
    /////////////////////////////////////////////////////
    virtual void onAnswer(const irr::s32& answerId) = 0;


	void Draw();


	bool OnEvent(const irr::SEvent&);

    // TODO to remove
//    static CSpeech* createSpeech(const std::string& );
protected:
};

#endif
